<?php
/**
 *
 * @author            alain91
 * @copyright      (C) 2009 Alain Gandon
 * @email              alain091@gmail.com
 * @license           GPL Version 2
 */

function safe_alter_add_column($table, $column, $arg)
{
	global $Sql;

	$query = $Sql->query_inject('SHOW COLUMNS FROM '.PREFIX.$table.' LIKE \''.$column.'\'', __LINE__, __FILE__);
	$result = $Sql->fetch_assoc($query);
	if ($result === FALSE)
	{
		$Sql->query_inject("ALTER TABLE `".PREFIX.$table."` ADD COLUMN ".$column." ".$arg, __LINE__, __FILE__);
	}
	else
	{
		echo "Le champ ".$column." existe dej dans la table ".PREFIX.$table."<br>\n";
		return FALSE;
	}
	return TRUE;
}

function safe_alter_add_index($table, $index_name, $column, $option='')
{
	global $Sql;
	
	$query = $Sql->query_inject('SHOW COLUMNS FROM '.PREFIX.$table.' LIKE \''.$column.'\'', __LINE__, __FILE__);
	$result = $Sql->fetch_assoc($query);
	if ($result === FALSE)
	{
		echo "Le champ ".$column." n'existe pas dans la table ".PREFIX.$table."<br>\n";
		return FALSE;
	}
	
	$query = $Sql->query_inject('SHOW INDEX FROM '.PREFIX.$table, __LINE__, __FILE__);
	$found = FALSE;
	while( $result = $Sql->fetch_assoc($query) )
	{
		if ($result['Column_name'] == $column)
		{
			$found = true;
			break;
		}
	}
	if ($found === FALSE)
	{
		$Sql->query_inject("ALTER TABLE `".PREFIX.$table."` ADD ".$option." INDEX ".$index_name." (".$column.")", __LINE__, __FILE__);
	}
	else
	{
		echo "Un index sur le champ ". $column ." existe dej dans la table ".PREFIX.$table."<br>\n";
		return FALSE;
	}
	return TRUE;
}

safe_alter_add_column('smallads', 'vid', 'INT(11) NOT NULL DEFAULT 0');
safe_alter_add_index('smallads', 'vid', 'vid');
safe_alter_add_index('smallads', 'date_approved', 'date_approved');
safe_alter_add_index('smallads', 'approved', 'approved');
safe_alter_add_index('smallads', 'id_created', 'id_created');

?>
