-- 
-- Structure de la table `phpboost_smallads`
-- 

DROP TABLE IF EXISTS `phpboost_smallads`;
CREATE TABLE IF NOT EXISTS `phpboost_smallads` (
  `id` int(11) NOT NULL auto_increment,
  `cat_id` int(11),
  `title` varchar(63) NOT NULL default '',
  `contents` text NOT NULL default '',
  `picture` varchar(63) NOT NULL default '',
  `id_created` int(11) NOT NULL default 0,
  `date_created` int(11) NOT NULL default 0,
  `type` tinyint(4) NOT NULL default 0,
  `price` FLOAT NOT NULL default 0.0,
  `approved` tinyint(1) unsigned NOT NULL default 0,
  `date_approved` int(11) NOT NULL default 0,
  `id_updated` int(11) NOT NULL default 0,
  `date_updated` int(11) NOT NULL default 0,
  `links_flag` int(11) NOT NULL default 0,
  `vid` int(11) NOT NULL DEFAULT 0,
  `max_weeks` int(11),
  PRIMARY KEY  (`id`),
  KEY `date_created` (`date_created`),
  KEY `vid` (`vid`),
  KEY `date_approved` (`date_approved`),
  KEY `approved` (`approved`),
  KEY `id_created` (`id_created`)
) ENGINE=MyISAM AUTO_INCREMENT=1 ;
